Index: pjproject/trunk/pjsip-apps/src/python/_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2158)
+++ pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2163)
@@ -20,5 +20,5 @@
 
 #define THIS_FILE    "main.c"
-#define POOL_SIZE    4000
+#define POOL_SIZE    512
 #define SND_DEV_NUM  64
 #define SND_NAME_LEN  64
@@ -26,9 +26,38 @@
 /* LIB BASE */
 
-static PyObject* obj_log_cb;
-static long thread_id;
-
-#define ENTER_PYTHON()	    PyGILState_STATE state = PyGILState_Ensure()
-#define LEAVE_PYTHON()	    PyGILState_Release(state)
+static PyObject* g_obj_log_cb;
+static long g_thread_id;
+static struct py_thread_desc
+{
+    struct py_thread_desc *next;
+    pj_thread_desc	   desc;
+} *py_thread_desc;
+
+/*
+ * The global callback object.
+ */
+static PyObj_pjsua_callback * g_obj_callback;
+
+/* Set this to 1 if all threads are created by Python */
+#define NO_PJSIP_THREAD 1
+
+#if NO_PJSIP_THREAD
+#   define ENTER_PYTHON()
+#   define LEAVE_PYTHON()
+#else
+#   define ENTER_PYTHON()   PyGILState_STATE state = PyGILState_Ensure()
+#   define LEAVE_PYTHON()   PyGILState_Release(state)
+#endif
+
+
+static void clear_py_thread_desc(void)
+{
+    while (py_thread_desc) {
+	struct py_thread_desc *next = py_thread_desc->next;
+	free(py_thread_desc);
+	py_thread_desc = next;
+    }
+}
+
 
 /*
@@ -42,27 +71,28 @@
      * or otherwise it will crash Python.
      */
-    if (pj_thread_local_get(thread_id) == 0)
+    if (pj_thread_local_get(g_thread_id) == 0)
 	return;
 
-    if (PyCallable_Check(obj_log_cb))
-    {
+    if (PyCallable_Check(g_obj_log_cb)) {
+	PyObject *param_data;
+
 	ENTER_PYTHON();
 
-        PyObject_CallFunctionObjArgs(
-            obj_log_cb, Py_BuildValue("i",level),
-            PyString_FromString(data), Py_BuildValue("i",len), NULL
+	param_data = PyString_FromStringAndSize(data, len);
+
+        PyObject_CallFunction(
+            g_obj_log_cb, 
+	    "iOi",
+	    level,
+            param_data, 
+	    len, 
+	    NULL
         );
 
+	Py_DECREF(param_data);
+
 	LEAVE_PYTHON();
     }
 }
-
-
-
-/*
- * The global callback object.
- */
-static PyObj_pjsua_callback * g_obj_callback;
-
 
 /*
@@ -72,22 +102,23 @@
 static void cb_on_call_state(pjsua_call_id call_id, pjsip_event *e)
 {
-    if (PyCallable_Check(g_obj_callback->on_call_state))
-    {	
-        PyObj_pjsip_event * obj;
+    PJ_UNUSED_ARG(e);
+
+    if (PyCallable_Check(g_obj_callback->on_call_state)) {	
+        PyObject * obj;
 
 	ENTER_PYTHON();
 
-	obj = (PyObj_pjsip_event *)PyType_GenericNew(&PyTyp_pjsip_event,
-						      NULL, NULL);
+	obj = Py_BuildValue("");
 		
-	obj->event = e;
-		
-        PyObject_CallFunctionObjArgs(
+        PyObject_CallFunction(
             g_obj_callback->on_call_state,
-	    Py_BuildValue("i",call_id),
+	    "iO",
+	    call_id,
 	    obj,
 	    NULL
         );
 
+	Py_DECREF(obj);
+
 	LEAVE_PYTHON();
     }
@@ -102,22 +133,24 @@
                                 pjsip_rx_data *rdata)
 {
-    if (PyCallable_Check(g_obj_callback->on_incoming_call))
-    {
-	PyObj_pjsip_rx_data * obj;
+    PJ_UNUSED_ARG(rdata);
+
+    if (PyCallable_Check(g_obj_callback->on_incoming_call)) {
+	PyObject *obj;
 
 	ENTER_PYTHON();
 
-	obj = (PyObj_pjsip_rx_data *)PyType_GenericNew(&PyTyp_pjsip_rx_data, 
-							NULL, NULL);
-	obj->rdata = rdata;
-
-        PyObject_CallFunctionObjArgs(
+	obj = Py_BuildValue("");
+
+        PyObject_CallFunction(
                 g_obj_callback->on_incoming_call,
-		Py_BuildValue("i",acc_id),
-                Py_BuildValue("i",call_id),
+		"iiO",
+		acc_id,
+                call_id,
 		obj,
 		NULL
         );
 
+	Py_DECREF(obj);
+
 	LEAVE_PYTHON();
     }
@@ -131,6 +164,6 @@
 static void cb_on_call_media_state(pjsua_call_id call_id)
 {
-    if (PyCallable_Check(g_obj_callback->on_call_media_state))
-    {
+    if (PyCallable_Check(g_obj_callback->on_call_media_state)) {
+
 	ENTER_PYTHON();
 
@@ -153,6 +186,5 @@
 static void cb_on_dtmf_digit(pjsua_call_id call_id, int digit)
 {
-    if (PyCallable_Check(g_obj_callback->on_dtmf_digit))
-    {
+    if (PyCallable_Check(g_obj_callback->on_dtmf_digit)) {
 	char digit_str[10];
 
@@ -161,8 +193,9 @@
 	pj_ansi_snprintf(digit_str, sizeof(digit_str), "%c", digit);
 
-        PyObject_CallFunctionObjArgs(
+        PyObject_CallFunction(
 	    g_obj_callback->on_dtmf_digit,
-	    Py_BuildValue("i",call_id),
-	    PyString_FromString(digit_str),
+	    "is",
+	    call_id,
+	    digit_str,
 	    NULL
 	);
@@ -181,18 +214,23 @@
 				        pjsip_status_code *code)
 {
-    if (PyCallable_Check(g_obj_callback->on_call_transfer_request))
-    {
-	PyObject * ret;
+    if (PyCallable_Check(g_obj_callback->on_call_transfer_request)) {
+	PyObject *ret, *param_dst;
 	int cd;
 
 	ENTER_PYTHON();
 
-        ret = PyObject_CallFunctionObjArgs(
-            g_obj_callback->on_call_transfer_request,
-	    Py_BuildValue("i",call_id),
-            PyString_FromStringAndSize(dst->ptr, dst->slen),
-            Py_BuildValue("i",*code),
-	    NULL
-        );
+	param_dst = PyString_FromPJ(dst);
+
+        ret = PyObject_CallFunction(
+		    g_obj_callback->on_call_transfer_request,
+		    "iOi",
+		    call_id,
+		    param_dst,
+		    *code,
+		    NULL
+		);
+
+	Py_DECREF(param_dst);
+
 	if (ret != NULL) {
 	    if (ret != Py_None) {
@@ -201,4 +239,5 @@
 		}
 	    }
+	    Py_DECREF(ret);
 	}
 
@@ -221,26 +260,32 @@
 					pj_bool_t *p_cont)
 {
-    if (PyCallable_Check(g_obj_callback->on_call_transfer_status))
-    {
-	PyObject * ret;
-	int cnt;
+    if (PyCallable_Check(g_obj_callback->on_call_transfer_status)) {
+	PyObject *ret, *param_reason;
 
 	ENTER_PYTHON();
 
-        ret = PyObject_CallFunctionObjArgs(
-            g_obj_callback->on_call_transfer_status,
-	    Py_BuildValue("i",call_id),
-	    Py_BuildValue("i",status_code),
-            PyString_FromStringAndSize(status_text->ptr, status_text->slen),
-	    Py_BuildValue("i",final),
-            Py_BuildValue("i",*p_cont),
-	    NULL
-        );
+	param_reason = PyString_FromPJ(status_text);
+
+        ret = PyObject_CallFunction(
+		    g_obj_callback->on_call_transfer_status,
+		    "iiOii",
+		    call_id,
+		    status_code,
+		    param_reason,
+		    final,
+		    *p_cont,
+		    NULL
+		);
+
+	Py_DECREF(param_reason);
+
 	if (ret != NULL) {
 	    if (ret != Py_None) {
+		int cnt;
 		if (PyArg_Parse(ret,"i",&cnt)) {
 		    *p_cont = cnt;
 		}
 	    }
+	    Py_DECREF(ret);
 	}
 
@@ -260,33 +305,37 @@
 					pj_str_t *st_text)
 {
-    if (PyCallable_Check(g_obj_callback->on_call_replace_request))
-    {
-	PyObject * ret;
-	PyObject * txt;
+    PJ_UNUSED_ARG(rdata);
+
+    if (PyCallable_Check(g_obj_callback->on_call_replace_request)) {
+	PyObject *ret, *param_reason, *param_rdata;
 	int cd;
-        PyObj_pjsip_rx_data * obj;
 
 	ENTER_PYTHON();
 
-	obj = (PyObj_pjsip_rx_data *)PyType_GenericNew(&PyTyp_pjsip_rx_data,
-							NULL, NULL);
-        obj->rdata = rdata;
-
-        ret = PyObject_CallFunctionObjArgs(
-            g_obj_callback->on_call_replace_request,
-	    Py_BuildValue("i",call_id),
-	    obj,
-	    Py_BuildValue("i",*st_code),
-            PyString_FromStringAndSize(st_text->ptr, st_text->slen),
-	    NULL
-        );
+	param_reason = PyString_FromPJ(st_text);
+	param_rdata = Py_BuildValue("");
+
+        ret = PyObject_CallFunction(
+		    g_obj_callback->on_call_replace_request,
+		    "iOiO",
+		    call_id,
+		    param_rdata,
+		    *st_code,
+		    param_reason,
+		    NULL
+		);
+
+	Py_DECREF(param_rdata);
+	Py_DECREF(param_reason);
+
 	if (ret != NULL) {
 	    if (ret != Py_None) {
+		PyObject * txt;
 		if (PyArg_ParseTuple(ret,"iO",&cd, &txt)) {
 		    *st_code = cd;
-		    st_text->ptr = PyString_AsString(txt);
-		    st_text->slen = strlen(PyString_AsString(txt));
+		    *st_text = PyString_ToPJ(txt);
 		}
 	    }
+	    Py_DECREF(ret);
 	}
 
@@ -304,12 +353,12 @@
 				pjsua_call_id new_call_id)
 {
-    if (PyCallable_Check(g_obj_callback->on_call_replaced))
-    {
+    if (PyCallable_Check(g_obj_callback->on_call_replaced)) {
 	ENTER_PYTHON();
 
-        PyObject_CallFunctionObjArgs(
+        PyObject_CallFunction(
             g_obj_callback->on_call_replaced,
-	    Py_BuildValue("i",old_call_id),
-	    Py_BuildValue("i",new_call_id),
+	    "ii",
+	    old_call_id,
+	    new_call_id,
 	    NULL
         );
@@ -326,6 +375,5 @@
 static void cb_on_reg_state(pjsua_acc_id acc_id)
 {
-    if (PyCallable_Check(g_obj_callback->on_reg_state))
-    {
+    if (PyCallable_Check(g_obj_callback->on_reg_state)) {
 	ENTER_PYTHON();
 
@@ -358,18 +406,51 @@
     PJ_UNUSED_ARG(msg_data);
 
-    if (PyCallable_Check(g_obj_callback->on_incoming_subscribe))
-    {
-	PyObject *ret;
+    if (PyCallable_Check(g_obj_callback->on_incoming_subscribe)) {
+	PyObject *ret, *param_from, *param_contact, *param_srv_pres;
+	pjsip_contact_hdr *contact_hdr;
+	pj_pool_t *pool = NULL;
 
 	ENTER_PYTHON();
 
-        ret = PyObject_CallFunctionObjArgs(
-	    g_obj_callback->on_incoming_subscribe,
-	    Py_BuildValue("i", acc_id),
-	    Py_BuildValue("i", buddy_id),
-	    PyString_FromStringAndSize(from->ptr, from->slen),
-	    PyLong_FromLong((long)srv_pres),
-	    NULL
-	);
+	param_from = PyString_FromPJ(from);
+	param_srv_pres = PyLong_FromLong((long)srv_pres);
+
+	contact_hdr = (pjsip_contact_hdr*)
+		      pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT,
+					 NULL);
+	if (contact_hdr) {
+	    char *contact;
+	    int len;
+
+	    pool = pjsua_pool_create("pytmp", 512, 512);
+	    contact = (char*) pj_pool_alloc(pool, PJSIP_MAX_URL_SIZE+1);
+	    len = pjsip_uri_print(PJSIP_URI_IN_CONTACT_HDR, contact_hdr->uri, 
+				  contact, PJSIP_MAX_URL_SIZE);
+	    if (len < 1)
+		len = 0;
+	    contact[len] = '\0';
+
+	    param_contact = PyString_FromStringAndSize(contact, len);
+	} else {
+	    param_contact = Py_BuildValue("");
+	}
+
+        ret = PyObject_CallFunction(
+		    g_obj_callback->on_incoming_subscribe,
+		    "iiOOO",
+		    acc_id,
+		    buddy_id,
+		    param_from,
+		    param_contact,
+		    param_srv_pres,
+		    NULL
+		);
+
+	if (pool)
+	    pj_pool_release(pool);
+
+	Py_DECREF(param_from);
+	Py_DECREF(param_contact);
+	Py_DECREF(param_srv_pres);
 
 	if (ret && PyTuple_Check(ret)) {
@@ -379,11 +460,12 @@
 		if (PyTuple_GetItem(ret, 1) != Py_None) {
 		    pj_str_t tmp;
-		    tmp = PyString_to_pj_str(PyTuple_GetItem(ret, 1));
+		    tmp = PyString_ToPJ(PyTuple_GetItem(ret, 1));
 		    reason->ptr = reason_buf;
 		    pj_strncpy(reason, &tmp, sizeof(reason_buf));
 		} else {
+		    reason->slen = 0;
 		}
 	    }
-
+	    Py_XDECREF(ret);
 	} else if (ret) {
 	    Py_XDECREF(ret);
@@ -400,6 +482,5 @@
 static void cb_on_buddy_state(pjsua_buddy_id buddy_id)
 {
-    if (PyCallable_Check(g_obj_callback->on_buddy_state))
-    {
+    if (PyCallable_Check(g_obj_callback->on_buddy_state)) {
 	ENTER_PYTHON();
 
@@ -426,19 +507,34 @@
     PJ_UNUSED_ARG(rdata);
 
-    if (PyCallable_Check(g_obj_callback->on_pager))
-    {
+    if (PyCallable_Check(g_obj_callback->on_pager)) {
+	PyObject *param_from, *param_to, *param_contact, *param_mime_type,
+		 *param_body;
+
 	ENTER_PYTHON();
 
-        PyObject_CallFunctionObjArgs(
-            g_obj_callback->on_pager,
-	    Py_BuildValue("i",call_id),
-            PyString_FromStringAndSize(from->ptr, from->slen),
-            PyString_FromStringAndSize(to->ptr, to->slen),
-            PyString_FromStringAndSize(contact->ptr, contact->slen),
-            PyString_FromStringAndSize(mime_type->ptr, mime_type->slen),
-            PyString_FromStringAndSize(body->ptr, body->slen), 
-	    Py_BuildValue("i",acc_id),
-            NULL
-        );
+	param_from = PyString_FromPJ(from);
+	param_to = PyString_FromPJ(to);
+	param_contact = PyString_FromPJ(contact);
+	param_mime_type = PyString_FromPJ(mime_type);
+	param_body = PyString_FromPJ(body);
+
+        PyObject_CallFunction(
+		g_obj_callback->on_pager,
+		"iOOOOOi",
+		call_id,
+		param_from,
+		param_to,
+		param_contact,
+		param_mime_type,
+		param_body, 
+		acc_id,
+		NULL
+	    );
+
+	Py_DECREF(param_body);
+	Py_DECREF(param_mime_type);
+	Py_DECREF(param_contact);
+	Py_DECREF(param_to);
+	Py_DECREF(param_from);
 
 	LEAVE_PYTHON();
@@ -459,7 +555,8 @@
 				pjsua_acc_id acc_id)
 {
-    if (PyCallable_Check(g_obj_callback->on_pager))
-    {
-	PyObject * obj_user_data;
+    if (PyCallable_Check(g_obj_callback->on_pager)) {
+	PyObject *param_call_id, *param_to, *param_body,
+		 *param_user_data, *param_status, *param_reason,
+		 *param_acc_id;
 
 	ENTER_PYTHON();
@@ -468,17 +565,23 @@
 	PJ_UNUSED_ARG(rdata);
 
-	obj_user_data = Py_BuildValue("i", user_data);
-
         PyObject_CallFunctionObjArgs(
-            g_obj_callback->on_pager_status,
-	    Py_BuildValue("i",call_id),
-            PyString_FromStringAndSize(to->ptr, to->slen),
-            PyString_FromStringAndSize(body->ptr, body->slen), 
-	    obj_user_data,
-            Py_BuildValue("i",status),
-	    PyString_FromStringAndSize(reason->ptr,reason->slen),
-	    Py_BuildValue("i",acc_id),
-	    NULL
-        );
+		g_obj_callback->on_pager_status,
+		param_call_id	= Py_BuildValue("i",call_id),
+		param_to	= PyString_FromPJ(to),
+		param_body	= PyString_FromPJ(body), 
+		param_user_data = Py_BuildValue("i", user_data),
+		param_status	= Py_BuildValue("i",status),
+		param_reason	= PyString_FromPJ(reason),
+		param_acc_id	= Py_BuildValue("i",acc_id),
+		NULL
+	    );
+
+	Py_DECREF(param_call_id);
+	Py_DECREF(param_to);
+	Py_DECREF(param_body);
+	Py_DECREF(param_user_data);
+	Py_DECREF(param_status);
+	Py_DECREF(param_reason);
+	Py_DECREF(param_acc_id);
 
 	LEAVE_PYTHON();
@@ -496,6 +599,8 @@
 			    pjsua_acc_id acc_id)
 {
-    if (PyCallable_Check(g_obj_callback->on_typing))
-    {
+    if (PyCallable_Check(g_obj_callback->on_typing)) {
+	PyObject *param_call_id, *param_from, *param_to, *param_contact,
+		 *param_is_typing, *param_acc_id;
+
 	ENTER_PYTHON();
 
@@ -503,12 +608,20 @@
 
         PyObject_CallFunctionObjArgs(
-            g_obj_callback->on_typing,Py_BuildValue("i",call_id),
-            PyString_FromStringAndSize(from->ptr, from->slen),
-            PyString_FromStringAndSize(to->ptr, to->slen),
-            PyString_FromStringAndSize(contact->ptr, contact->slen),
-            Py_BuildValue("i",is_typing),
-	    Py_BuildValue("i",acc_id),
-	    NULL
-        );
+		g_obj_callback->on_typing,
+		param_call_id	= Py_BuildValue("i",call_id),
+		param_from	= PyString_FromPJ(from),
+		param_to	= PyString_FromPJ(to),
+		param_contact	= PyString_FromPJ(contact),
+		param_is_typing = Py_BuildValue("i",is_typing),
+		param_acc_id	= Py_BuildValue("i",acc_id),
+		NULL
+	    );
+
+	Py_DECREF(param_call_id);
+	Py_DECREF(param_from);
+	Py_DECREF(param_to);
+	Py_DECREF(param_contact);
+	Py_DECREF(param_is_typing); 
+	Py_DECREF(param_acc_id);
 
 	LEAVE_PYTHON();
@@ -530,18 +643,18 @@
 	int i;
 
-        for (i = 0; i < PyList_Size(py_hdr_list); i++) 
-	{ 
+        for (i=0; i<PyList_Size(py_hdr_list); ++i)  { 
             pj_str_t hname, hvalue;
 	    pjsip_generic_string_hdr * new_hdr;
             PyObject * tuple = PyList_GetItem(py_hdr_list, i);
 
-            if (PyTuple_Check(tuple)) 
-	    {
-                hname.ptr = PyString_AsString(PyTuple_GetItem(tuple,0));
-                hname.slen = strlen(PyString_AsString
-					(PyTuple_GetItem(tuple,0)));
-                hvalue.ptr = PyString_AsString(PyTuple_GetItem(tuple,1));
-                hvalue.slen = strlen(PyString_AsString
-					(PyTuple_GetItem(tuple,1)));
+            if (PyTuple_Check(tuple)) {
+		if (PyTuple_Size(tuple) >= 1)
+		    hname = PyString_ToPJ(PyTuple_GetItem(tuple,0));
+		else
+		    hname.slen = 0;
+		if (PyTuple_Size(tuple) >= 2)
+		    hvalue = PyString_ToPJ(PyTuple_GetItem(tuple,1));
+		else
+		    hvalue.slen = 0;
             } else {
 		hname.ptr = "";
@@ -556,86 +669,30 @@
 }
 
-/* 
- * translate_hdr_rev
- * internal function
- * translate from pjsip_generic_string_hdr to hdr_list
- */
-
-void translate_hdr_rev(pjsip_generic_string_hdr *hdr, PyObject *py_hdr_list)
-{
-    int i;
-    int len;
-    pjsip_generic_string_hdr * p_hdr;
-
-    len = pj_list_size(hdr);
-    
-    if (len > 0) 
-    {
-        p_hdr = hdr;
-        Py_XDECREF(py_hdr_list);
-        py_hdr_list = PyList_New(len);
-
-        for (i = 0; i < len && p_hdr != NULL; i++) 
-	{
-            PyObject * tuple;
-            PyObject * str;
-
-            tuple = PyTuple_New(2);
-	    
-            str = PyString_FromStringAndSize(p_hdr->name.ptr, p_hdr->name.slen);
-            PyTuple_SetItem(tuple, 0, str);
-            str = PyString_FromStringAndSize
-		(hdr->hvalue.ptr, p_hdr->hvalue.slen);
-            PyTuple_SetItem(tuple, 1, str);
-            PyList_SetItem(py_hdr_list, i, tuple);
-            p_hdr = p_hdr->next;
-	}
-    }
-    
-    
-}
-
 /*
  * py_pjsua_thread_register
- * !added @ 061206
  */
 static PyObject *py_pjsua_thread_register(PyObject *pSelf, PyObject *pArgs)
 {
-	
     pj_status_t status;	
     const char *name;
     PyObject *py_desc;
     pj_thread_t *thread;
-    void *thread_desc;
-#if 0
-    int size;
-    int i;
-    int *td;
-#endif
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "sO", &name, &py_desc))
-    {
+    struct py_thread_desc *thread_desc;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "sO", &name, &py_desc)) {
          return NULL;
     }
-#if 0
-    size = PyList_Size(py_desc);
-    td = (int *)malloc(size * sizeof(int));
-    for (i = 0; i < size; i++) 
-    {
-	if (!PyArg_Parse(PyList_GetItem(py_desc,i),"i", td[i])) 
-	{
-	    return NULL;
-	}
-    }
-    thread_desc = td;
-#else
-    thread_desc = malloc(sizeof(pj_thread_desc));
-#endif
-    status = pj_thread_register(name, thread_desc, &thread);
+    thread_desc = (struct py_thread_desc*)
+		  malloc(sizeof(struct py_thread_desc));
+    thread_desc->next = py_thread_desc;
+    py_thread_desc = thread_desc;
+
+    status = pj_thread_register(name, thread_desc->desc, &thread);
 
     if (status == PJ_SUCCESS)
-	status = pj_thread_local_set(thread_id, (void*)1);
+	status = pj_thread_local_set(g_thread_id, (void*)1);
+
     return Py_BuildValue("i",status);
 }
@@ -643,8 +700,7 @@
 /*
  * py_pjsua_logging_config_default
- * !modified @ 051206
  */
 static PyObject *py_pjsua_logging_config_default(PyObject *pSelf,
-                                                    PyObject *pArgs)
+                                                 PyObject *pArgs)
 {
     PyObj_pjsua_logging_config *obj;	
@@ -652,16 +708,13 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    
+    PJ_UNUSED_ARG(pArgs);
+
     pjsua_logging_config_default(&cfg);
-    obj = (PyObj_pjsua_logging_config *) PyObj_pjsua_logging_config_new
-		(&PyTyp_pjsua_logging_config,NULL,NULL);
+    obj = (PyObj_pjsua_logging_config*) 
+	  PyObj_pjsua_logging_config_new(&PyTyp_pjsua_logging_config, 
+					 NULL, NULL);
     PyObj_pjsua_logging_config_import(obj, &cfg);
     
-    return (PyObject *)obj;
+    return (PyObject*)obj;
 }
 
@@ -669,5 +722,4 @@
 /*
  * py_pjsua_config_default
- * !modified @ 051206
  */
 static PyObject *py_pjsua_config_default(PyObject *pSelf, PyObject *pArgs)
@@ -677,14 +729,12 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pArgs);
+
     pjsua_config_default(&cfg);
-    obj = (PyObj_pjsua_config *) PyObj_pjsua_config_new(&PyTyp_pjsua_config, NULL, NULL);
+    obj = (PyObj_pjsua_config *) PyObj_pjsua_config_new(&PyTyp_pjsua_config, 
+							NULL, NULL);
     PyObj_pjsua_config_import(obj, &cfg);
 
-    return (PyObject *)obj;
+    return (PyObject*)obj;
 }
 
@@ -692,5 +742,4 @@
 /*
  * py_pjsua_media_config_default
- * !modified @ 051206
  */
 static PyObject * py_pjsua_media_config_default(PyObject *pSelf,
@@ -701,13 +750,11 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pArgs);
+
     pjsua_media_config_default(&cfg);
     obj = (PyObj_pjsua_media_config *)
 	  PyType_GenericNew(&PyTyp_pjsua_media_config, NULL, NULL);
     PyObj_pjsua_media_config_import(obj, &cfg);
+
     return (PyObject *)obj;
 }
@@ -716,31 +763,12 @@
 /*
  * py_pjsua_msg_data_init
- * !modified @ 051206
  */
 static PyObject *py_pjsua_msg_data_init(PyObject *pSelf, PyObject *pArgs)
 {
-    PyObj_pjsua_msg_data *obj;
-    pjsua_msg_data msg;
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    pjsua_msg_data_init(&msg);
-    obj = (PyObj_pjsua_msg_data *)PyObj_pjsua_msg_data_new(&PyTyp_pjsua_msg_data, NULL, NULL);
-    Py_XDECREF(obj->content_type);
-    obj->content_type = PyString_FromStringAndSize(
-        msg.content_type.ptr, msg.content_type.slen
-    );
-    Py_XDECREF(obj->msg_body);
-    obj->msg_body = PyString_FromStringAndSize(
-        msg.msg_body.ptr, msg.msg_body.slen
-    );
-
-    translate_hdr_rev((pjsip_generic_string_hdr *)&msg.hdr_list,obj->hdr_list);
-    
-    return (PyObject *)obj;
+    PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
+
+    return (PyObject *)PyObj_pjsua_msg_data_new(&PyTyp_pjsua_msg_data, 
+						NULL, NULL);
 }
 
@@ -749,29 +777,29 @@
  * py_pjsua_reconfigure_logging
  */
-static PyObject *py_pjsua_reconfigure_logging(PyObject *pSelf, PyObject *pArgs)
-{
-    PyObject * logObj;
-    PyObj_pjsua_logging_config *log;
-    pjsua_logging_config cfg;
+static PyObject *py_pjsua_reconfigure_logging(PyObject *pSelf, 
+					      PyObject *pArgs)
+{
+    PyObject *logObj;
     pj_status_t status;
 
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "O", &logObj))
-    {
-        return NULL;
-    }
-    if (logObj != Py_None) 
-    {
-        log = (PyObj_pjsua_logging_config *)logObj;
+    if (!PyArg_ParseTuple(pArgs, "O", &logObj)) {
+        return NULL;
+    }
+
+    if (logObj != Py_None) {
+	PyObj_pjsua_logging_config *log;
+	pjsua_logging_config cfg;
+
+        log = (PyObj_pjsua_logging_config*)logObj;
         cfg.msg_logging = log->msg_logging;
         cfg.level = log->level;
         cfg.console_level = log->console_level;
         cfg.decor = log->decor;
-        cfg.log_filename.ptr = PyString_AsString(log->log_filename);
-        cfg.log_filename.slen = strlen(cfg.log_filename.ptr);
-        Py_XDECREF(obj_log_cb);
-        obj_log_cb = log->cb;
-        Py_INCREF(obj_log_cb);
+        cfg.log_filename = PyString_ToPJ(log->log_filename);
+        Py_XDECREF(g_obj_log_cb);
+        g_obj_log_cb = log->cb;
+        Py_INCREF(g_obj_log_cb);
         cfg.cb = &cb_log_cb;
         status = pjsua_reconfigure_logging(&cfg);
@@ -779,100 +807,6 @@
         status = pjsua_reconfigure_logging(NULL);
     }
+
     return Py_BuildValue("i",status);
-}
-
-
-/*
- * py_pjsua_pool_create
- */
-static PyObject *py_pjsua_pool_create(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_size_t init_size;
-    pj_size_t increment;
-    const char * name;
-    pj_pool_t *p;
-    PyObj_pj_pool *pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "sII", &name, &init_size, &increment))
-    {
-        return NULL;
-    }
-    
-    p = pjsua_pool_create(name, init_size, increment);
-    pool = (PyObj_pj_pool *)PyType_GenericNew(&PyTyp_pj_pool_t, NULL, NULL);
-    pool->pool = p;
-    return (PyObject *)pool;
-
-}
-
-
-/*
- * py_pjsua_get_pjsip_endpt
- */
-static PyObject *py_pjsua_get_pjsip_endpt(PyObject *pSelf, PyObject *pArgs)
-{
-    PyObj_pjsip_endpoint *endpt;
-    pjsip_endpoint *e;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    e = pjsua_get_pjsip_endpt();
-    endpt = (PyObj_pjsip_endpoint *)PyType_GenericNew(
-        &PyTyp_pjsip_endpoint, NULL, NULL
-    );
-    endpt->endpt = e;
-    return (PyObject *)endpt;
-}
-
-
-/*
- * py_pjsua_get_pjmedia_endpt
- */
-static PyObject *py_pjsua_get_pjmedia_endpt(PyObject *pSelf, PyObject *pArgs)
-{
-    PyObj_pjmedia_endpt *endpt;
-    pjmedia_endpt *e;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    e = pjsua_get_pjmedia_endpt();
-    endpt = (PyObj_pjmedia_endpt *)PyType_GenericNew(
-        &PyTyp_pjmedia_endpt, NULL, NULL
-    );
-    endpt->endpt = e;
-    return (PyObject *)endpt;
-}
-
-
-/*
- * py_pjsua_get_pool_factory
- */
-static PyObject *py_pjsua_get_pool_factory(PyObject *pSelf, PyObject *pArgs)
-{
-    PyObj_pj_pool_factory *pool;
-    pj_pool_factory *p;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    p = pjsua_get_pool_factory();
-    pool = (PyObj_pj_pool_factory *)PyType_GenericNew(
-        &PyTyp_pj_pool_factory, NULL, NULL
-    );
-    pool->pool_fact = p;
-    return (PyObject *)pool;
 }
 
@@ -889,12 +823,11 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ssi", &sender, &title, &status))
-    {
+    if (!PyArg_ParseTuple(pArgs, "ssi", &sender, &title, &status)) {
         return NULL;
     }
 	
     pjsua_perror(sender, title, status);
-    Py_INCREF(Py_None);
-    return Py_None;
+
+    return Py_BuildValue("");
 }
 
@@ -908,16 +841,14 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pArgs);
+
     status = pjsua_create();
     
-    if (status == PJ_SUCCESS) 
-    {
-	status = pj_thread_local_alloc(&thread_id);
+    if (status == PJ_SUCCESS)  {
+	status = pj_thread_local_alloc(&g_thread_id);
 	if (status == PJ_SUCCESS)
-	    status = pj_thread_local_set(thread_id, (void*)1);
+	    status = pj_thread_local_set(g_thread_id, (void*)1);
+
+	pj_atexit(&clear_py_thread_desc);
     }
 
@@ -939,6 +870,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "OOO", &o_ua_cfg, &o_log_cfg, &o_media_cfg))
-    {
+    if (!PyArg_ParseTuple(pArgs, "OOO", &o_ua_cfg, &o_log_cfg, &o_media_cfg)) {
         return NULL;
     }
@@ -948,10 +878,10 @@
     pjsua_media_config_default(&cfg_media);
 
-    if (o_ua_cfg != Py_None) 
-    {
+    if (o_ua_cfg != Py_None) {
 	PyObj_pjsua_config *obj_ua_cfg = (PyObj_pjsua_config*)o_ua_cfg;
 
 	PyObj_pjsua_config_export(&cfg_ua, obj_ua_cfg);
 
+	Py_XDECREF(g_obj_callback);
     	g_obj_callback = obj_ua_cfg->cb;
     	Py_INCREF(g_obj_callback);
@@ -978,6 +908,5 @@
     }
 
-    if (o_log_cfg != Py_None) 
-    {
+    if (o_log_cfg != Py_None)  {
 	PyObj_pjsua_logging_config * obj_log;
 
@@ -986,7 +915,7 @@
         PyObj_pjsua_logging_config_export(&cfg_log, obj_log);
 
-        Py_XDECREF(obj_log_cb);
-        obj_log_cb = obj_log->cb;
-        Py_INCREF(obj_log_cb);
+        Py_XDECREF(g_obj_log_cb);
+        g_obj_log_cb = obj_log->cb;
+        Py_INCREF(g_obj_log_cb);
 
         cfg_log.cb = &cb_log_cb;
@@ -997,6 +926,5 @@
     }
 
-    if (o_media_cfg != Py_None) 
-    {
+    if (o_media_cfg != Py_None) {
 	PyObj_pjsua_media_config_export(&cfg_media, 
 				        (PyObj_pjsua_media_config*)o_media_cfg);
@@ -1008,5 +936,6 @@
 
     status = pjsua_init(p_cfg_ua, p_cfg_log, p_cfg_media);
-    return Py_BuildValue("i",status);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -1020,12 +949,9 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pArgs);
+
     status = pjsua_start();
     
-    return Py_BuildValue("i",status);
+    return Py_BuildValue("i", status);
 }
 
@@ -1039,12 +965,9 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pArgs);
+
     status = pjsua_destroy();
     
-    return Py_BuildValue("i",status);
+    return Py_BuildValue("i", status);
 }
 
@@ -1056,13 +979,16 @@
 {
     int ret;
-    unsigned msec;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "i", &msec))
-    {
-        return NULL;
-    }
-
+    int msec;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &msec)) {
+        return NULL;
+    }
+
+    if (msec < 0)
+	msec = 0;
+
+#if !NO_PJSIP_THREAD
     /* Since handle_events() will block, we must wrap it with ALLOW_THREADS
      * construct, or otherwise many Python blocking functions (such as
@@ -1071,8 +997,13 @@
      */
     Py_BEGIN_ALLOW_THREADS
+#endif
+
     ret = pjsua_handle_events(msec);
+
+#if !NO_PJSIP_THREAD
     Py_END_ALLOW_THREADS
-    
-    return Py_BuildValue("i",ret);
+#endif
+    
+    return Py_BuildValue("i", ret);
 }
 
@@ -1088,11 +1019,11 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "s", &url))
-    {
-        return NULL;
-    }
+    if (!PyArg_ParseTuple(pArgs, "s", &url)) {
+        return NULL;
+    }
+
     status = pjsua_verify_sip_url(url);
     
-    return Py_BuildValue("i",status);
+    return Py_BuildValue("i", status);
 }
 
@@ -1155,28 +1086,4 @@
     "c_url: The URL, as NULL terminated string.";
 
-static char pjsua_pool_create_doc[] =
-    "_pjsua.Pj_Pool _pjsua.pool_create (string name, int init_size, "
-                                            "int increment) "
-    "Create memory pool Parameters: "
-    "name: Optional pool name; "
-    "init_size: Initial size of the pool;  "
-    "increment: Increment size.";
-
-static char pjsua_get_pjsip_endpt_doc[] =
-    "_pjsua.Pjsip_Endpoint _pjsua.get_pjsip_endpt (void) "
-    "Internal function to get SIP endpoint instance of pjsua, which is needed "
-    "for example to register module, create transports, etc. Probably is only "
-    "valid after pjsua_init() is called.";
-
-static char pjsua_get_pjmedia_endpt_doc[] =
-    "_pjsua.Pjmedia_Endpt _pjsua.get_pjmedia_endpt (void) "
-    "Internal function to get media endpoint instance. Only valid after "
-    "pjsua_init() is called.";
-
-static char pjsua_get_pool_factory_doc[] =
-    "_pjsua.Pj_Pool_Factory _pjsua.get_pool_factory (void) "
-    "Internal function to get PJSUA pool factory. Only valid after "
-    "pjsua_init() is called.";
-
 static char pjsua_reconfigure_logging_doc[] =
     "int _pjsua.reconfigure_logging (_pjsua.Logging_Config c) "
@@ -1208,5 +1115,4 @@
 /*
  * py_pjsua_transport_config_default
- * !modified @ 051206
  */
 static PyObject *py_pjsua_transport_config_default(PyObject *pSelf, 
@@ -1217,8 +1123,5 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "")) {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pArgs);
 
     pjsua_transport_config_default(&cfg);
@@ -1233,5 +1136,4 @@
 /*
  * py_pjsua_transport_create
- * !modified @ 051206
  */
 static PyObject *py_pjsua_transport_create(PyObject *pSelf, PyObject *pArgs)
@@ -1239,5 +1141,5 @@
     pj_status_t status;
     int type;
-    PyObject * tmpObj;
+    PyObject *pCfg;
     pjsua_transport_config cfg;
     pjsua_transport_id id;
@@ -1245,11 +1147,12 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "iO", &type, &tmpObj)) {
-        return NULL;
-    }
-
-    if (tmpObj != Py_None) {
+    if (!PyArg_ParseTuple(pArgs, "iO", &type, &pCfg)) {
+        return NULL;
+    }
+
+    if (pCfg != Py_None) {
 	PyObj_pjsua_transport_config *obj;
-        obj = (PyObj_pjsua_transport_config*)tmpObj;
+
+        obj = (PyObj_pjsua_transport_config*)pCfg;
 	PyObj_pjsua_transport_config_export(&cfg, obj);
         status = pjsua_transport_create(type, &cfg, &id);
@@ -1264,5 +1167,4 @@
 /*
  * py_pjsua_enum_transports
- * !modified @ 261206
  */
 static PyObject *py_pjsua_enum_transports(PyObject *pSelf, PyObject *pArgs)
